Subject: Duplicate email address throws exception

Description

Since #29547 is resolved trying to store an email address that already exists throws an exception:
SQLSTATE[23000]: Integrity constraint violation: 1062 Duplicate entry 'xyz' for key
'flow3_identity_typo3_party_domain_model_electronicaddress'

The problem is, that it is not possible to find out whether an email exists already except for iterating over all party records.

One solution would be to remove the @FLOW3\Identity annotation from \ TYPO3\Party\Domain\Model\ ElectronicAddress::identifier
or to enable property paths (‘primaryElectronicAddress.identifier’) in QOM somehow.

Related issues:
related to TYPOS3.Flow - Feature # 30933: Check for unique constraints on add() Needs Feedbadd011-10-14
related to TYPOS3.Flow - Feature # 29547: @identity should make property uniqu... Resolved 2012-04-30

Associated revisions

Revision ed1f4b8b - 2012-05-21 13:49 - Bastian Waidelich

[BUGFIX] Duplicate email address throws exception

Since #29547 is resolved, trying to store an email address that
already exists throws an exception.
This change drops the unique indexes for "identifier", "type" and

"usagetype" from the ElectronicAddress domain model.

Change-Id: 11bf880e2f885318eaf3e9b64d7c3d0d3f094a3ab
Fixes: #37266

Related: #29547

Releases: 1.1, 1.2

Revision 9d10e013 - 2012-05-22 14:40 - Bastian Waidelich
[BUGFIX] Duplicate email address throws exception

Since #29547 is resolved, trying to store an email address that
already exists throws an exception.

This change drops the unique indexes for "identifier", "type" and
"usagetype" from the ElectronicAddress domain model.
Change-Id: 15921eb787254935246dc872596b699f8197dae0b

Fixes: #37266
Related: #29547
Releases: 1.1, 1.2

History

#1 - 2012-05-18 14:04 - Christian Miller

At least we should quickly come up with some solution. Removing the annotation is good but then we would have a breaking change if we reintroduce
it at some later point... Well maybe that's acceptable, atm the behaviour is broken really.

#2 - 2012-05-21 13:11 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11360

#3 - 2012-05-21 13:13 - Bastian Waidelich

Gerrit Code Review wrote:

Patch set 1 for branch master has been pushed to the review server.
It is available at http.//review.typo3.org/11360

This change reverts 38af75b9609c690eedbff6b393cc815e18f79d04 by dropping the unique constraints as discussed in todays scrum meeting

#4 - 2012-05-21 13:49 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11360

#5 - 2012-05-22 14:40 - Gerrit Code Review

Patch set 1 for branch FLOW3-1.1 has been pushed to the review server.

It is available at http://review.typo3.org/11446

#6 - 2012-05-22 14:41 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:ed1f4b8b69706db4f1d3dcab7e7283566711aaec.

#7 - 2015-03-16 17:33 - Christian Muller
- Target version deleted (1.1)
